/* VzImagination (C) 2018-2019 Stephane Charette <stephanecharette@gmail.com>
 * $Id: TestUtil.hpp 2741 2019-04-09 17:04:20Z stephane $
 */

#pragma once

#include <gtest/gtest.h>

#include "vzTypes.hpp"
#include "MatManip.hpp"
#include "Intervals.hpp"
#include "Imagination.hpp"


/// This is in TestUtilFilenames.cpp.in, and is manipulated at build time by cmake to include the set of test images.
std::string get_image_filenames_from_cmake();

/// Build the initial map of image names using what cmake has provided.  This is used by @ref copy_test_images().
vz::MStr get_test_images_map();

/// Make sure the test images are copied into the current working directory.  This is used by @ref test_images().
vz::MStr copy_test_images();

/** This is the method that the test scripts should be calling.  The map returned will contain a relative filename
 * as the key, and the image name (without extension) as the value.
 */
vz::MStr test_images();

/// Similar to @ref test_images(), but only returns the trivial images such as b.jpg, g.jpg, etc.
vz::MStr trivial_test_images();

/// Similar to @ref test_images(), but only returns the complex images such as capture.jpg, sudoku.jpg, etc.
vz::MStr complex_test_images();
